## mingw-w64-dcmtk-3.6.8-3.src.tar.zst

=== doxygen/CMakeLists.txt ===
# declare project
project(doxygen)

# doxygen support
if(DCMTK_WITH_DOXYGEN)

  if(DOXYGEN_EXECUTABLE)
    add_custom_target(DOXYGEN)
    add_custom_target(html "${DOXYGEN_EXECUTABLE}" htmldocs.tmp)
    add_dependencies(DOXYGEN html)
    if(DCMTK_ENABLE_MANPAGES)
      add_custom_target(man COMMAND "${DOXYGEN_EXECUTABLE}" manpages.tmp
                            COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/patchman.cmake")
      add_dependencies(DOXYGEN man)
      add_custom_target(man2text COMMAND "${CMAKE_COMMAND}" -E make_directory man2text
                                 COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/man2text.sh")
      add_dependencies(man2text man)
    endif()
  endif()

  # generate a tag file in order to link to this documentation from external projects
  if(DCMTK_GENERATE_DOXYGEN_TAGFILE)
    set(DOXYGEN_TAGFILE "dcmtk.tag")
  endif()

  # create configuration files (expand variables)
  set(DCMTK_VERSION "${DCMTK_PACKAGE_VERSION}${DCMTK_PACKAGE_VERSION_SUFFIX}")
  set(DOXYGEN_INPUT_DIR "${CMAKE_SOURCE_DIR}")
  set(DOXYGEN_DATA_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/htmldocs.cfg" "${CMAKE_CURRENT_BINARY_DIR}/htmldocs.tmp" ESCAPE_QUOTES @ONLY)
  if(DCMTK_ENABLE_MANPAGES)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/manpages.cfg" "${CMAKE_CURRENT_BINARY_DIR}/manpages.tmp" ESCAPE_QUOTES @ONLY)
  endif()

  # Make sure these directories exist when we try to install them
  install(CODE "file(MAKE_DIRECTORY \"${CMAKE_CURRENT_BINARY_DIR}/htmldocs\")" COMPONENT html)
  if(DCMTK_ENABLE_MANPAGES)
    install(CODE "file(MAKE_DIRECTORY \"${CMAKE_CURRENT_BINARY_DIR}/manpages\")" COMPONENT man)
  endif()

  # install html docs and manpages
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/htmldocs/" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}/html" COMPONENT html PATTERN "*.md5" EXCLUDE)
  if(DCMTK_GENERATE_DOXYGEN_TAGFILE)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${DOXYGEN_TAGFILE}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT html OPTIONAL)
  endif()
  if(DCMTK_ENABLE_MANPAGES)
    file(GLOB_RECURSE MANPAGES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/manpages/" "${CMAKE_CURRENT_SOURCE_DIR}/manpages/*.1")
    foreach(MANPAGE ${MANPAGES})
        if("${CMAKE_CURRENT_SOURCE_DIR}/manpages/${MANPAGE}" IS_NEWER_THAN "${CMAKE_CURRENT_BINARY_DIR}/manpages/${MANPAGE}")
            get_filename_component(DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/manpages/${MANPAGE}" PATH)
            file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/manpages/${MANPAGE}" DESTINATION "${DESTINATION}")
        endif()
    endforeach()
    install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/manpages/" DESTINATION "${CMAKE_INSTALL_MANDIR}" COMPONENT man PATTERN "*_.1" EXCLUDE)
  endif()

  # the files in manpages/ and htmldocs/ should be removed by "make clean".
  set(make_clean_files "${CMAKE_CURRENT_BINARY_DIR}/htmldocs" "${CMAKE_CURRENT_BINARY_DIR}/manpages" "${CMAKE_CURRENT_BINARY_DIR}/man2text")
  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${make_clean_files}")

  # the created files "htmldocs.tmp" and "manpages.tmp" should be removed with "make distclean",
  # which will (hopefully) be introduced in a future version, because they are only created during
  # the configure/generate process

else()

  if(DCMTK_ENABLE_MANPAGES)
    # since Doxygen is not available, install the pre-defined manpages, i.e. the ones shipped with this package
    install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/manpages/" DESTINATION "${CMAKE_INSTALL_MANDIR}" COMPONENT man)
  endif()

endif()

=== config/docs/CMakeLists.txt ===
# declare installation files
install(FILES config.txt dirstruc.txt envvars.txt macros.txt modules.txt DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT doc)

=== dcmpstat/libsrc/CMakeLists.txt ===
# create library from source files
DCMTK_ADD_LIBRARY(dcmpstat
  dcmpstat.cc
  dviface.cc
  dvpsab.cc
  dvpsabl.cc
  dvpsal.cc
  dvpsall.cc
  dvpscf.cc
  dvpscu.cc
  dvpscul.cc
  dvpsda.cc
  dvpsdal.cc
  dvpsfs.cc
  dvpsga.cc
  dvpsgal.cc
  dvpsgl.cc
  dvpsgll.cc
  dvpsgr.cc
  dvpsgrl.cc
  dvpshlp.cc
  dvpsib.cc
  dvpsibl.cc
  dvpsmsg.cc
  dvpsov.cc
  dvpsovl.cc
  dvpspl.cc
  dvpspl2.cc
  dvpspll.cc
  dvpspr.cc
  dvpsprt.cc
  dvpsri.cc
  dvpsril.cc
  dvpsrs.cc
  dvpsrsl.cc
  dvpssp.cc
  dvpsspl.cc
  dvpssv.cc
  dvpssvl.cc
  dvpstat.cc
  dvpstx.cc
  dvpstxl.cc
  dvpsvl.cc
  dvpsvll.cc
  dvpsvw.cc
  dvpsvwl.cc
  dvsighdl.cc
)

DCMTK_TARGET_LINK_MODULES(dcmpstat ofstd oflog dcmdata dcmiod dcmimgle dcmimage dcmnet dcmdsig dcmtls dcmsr dcmqrdb)

if (TARGET dcmpstat)
  set_property(TARGET dcmpstat PROPERTY OUTPUT_NAME "dcmpstat${DCMTK_TLS_LIBRARY_POSTFIX}")
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=dcmtk
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.6.8
pkgrel=3
pkgdesc="A collection of libraries and applications implementing large parts of the DICOM standard (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='http://dicom.offis.de/dcmtk'
msys2_repository_url="https://git.dcmtk.org/?p=dcmtk.git"
msys2_references=(
  "cpe: cpe:/a:offis:dcmtk"
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libsndfile"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-openjpeg2"
         "${MINGW_PACKAGE_PREFIX}-openssl"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-icu"
             "${MINGW_PACKAGE_PREFIX}-libiconv"
             "${MINGW_PACKAGE_PREFIX}-autotools")
optdepends=("${MINGW_PACKAGE_PREFIX}-icu"
            "${MINGW_PACKAGE_PREFIX}-libiconv")
source=("https://dicom.offis.de/download/dcmtk/dcmtk${pkgver//./}/${_realname}-${pkgver}.tar.gz"
        "001-fix-cmake-config-install-destination.patch"
        "002-properly-detect-canonical-host.patch"
        "003-fixed-compilation-with-gcc-15.patch"::"https://git.dcmtk.org/?p=dcmtk.git;a=patch;h=c29bebcd19bb963d72dcd00ca8745f60f6b9a39e")
sha256sums=('232076655503138debf2f624109f1799e539354f186ce4e04b27cf82a9d8720f'
            'ff124b6f26c5a5982268597c6285e2e320a248a090046b45618e79cb8a6fc099'
            'b9cd641267f9aeb055608f045cc91ad5b99b071897aa849ed3282aa03b5ae925'
            '46ead518b98b55d8eb442f7550b080891d74d6612bb89a1fd9426ee31a598ba1')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-cmake-config-install-destination.patch \
    002-properly-detect-canonical-host.patch \
    003-fixed-compilation-with-gcc-15.patch

  cd config
  ./rootconf
}

build() {
  # this is just to get arith.h
  cd "${srcdir}"/${_realname}-${pkgver}

  ./configure --ignore-deprecation
  make config-tests-all
  install -D config/include/dcmtk/config/arith.h "${srcdir}"/build-${MSYSTEM}/config/include/dcmtk/config/arith.h

  # continue the build using cmake
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DDCMTK_WITH_ICONV=ON \
      -DDCMTK_WITH_ICU=ON \
      -DDCMTK_WITH_LIBPNG=ON \
      -DDCMTK_WITH_LIBXML=ON \
      -DDCMTK_WITH_OPENJPEG=ON \
      -DDCMTK_WITH_OPENSSL=ON \
      -DDCMTK_WITH_SNDFILE=ON \
      -DDCMTK_WITH_TIFF=ON \
      -DDCMTK_WITH_ZLIB=ON \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/ctest.exe
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  # Fix pkgconfig file
  sed -e "s|${PREFIX_WIN}|\"\$\{prefix\}\"|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/pkgconfig/dcmtk.pc
  # Fix cmake-config files
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake" -type f -name '*.cmake' \
    -exec sed -i -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" {} \;

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYRIGHT" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
